const std    = @import("std");
const dvui   = @import("dvui");
const hncore = @import("hncore");

pub const App = struct {
    pub fn init(alloc: std.mem.Allocator) !App {
        _ = alloc;
        return App {
        };
    }
    pub fn deinit(self: *App) void {
        _ = self;
    }

    pub fn gui(self: *App) !void {
        _ = self;

        try gui_menu();
        try gui_main();
    }
    fn gui_menu() !void {
        var root = try dvui.menu(@src(), .horizontal, .{ .background = true, .expand = .horizontal });
        defer root.deinit();

        if (try dvui.menuItemLabel(@src(), "File", .{ .submenu = true }, .{})) |r| {
            var float = try dvui.floatingMenu(
                @src(), .{.from = dvui.Rect.fromPoint(dvui.Point{ .x = r.x, .y = r.y + r.h })}, .{});
            defer float.deinit();

            if (try dvui.menuItemLabel(@src(), "Open", .{}, .{})) |_| {
            }
        }
    }
    fn gui_main() !void {
        var box = try dvui.scrollArea(@src(), .{}, .{
            .expand     = .both,
            .color_fill = .{ .name = .fill_window },
            .padding    = dvui.Rect.all(8),
        });
        defer box.deinit();

        if (try dvui.button(@src(), "Zoom In", .{}, .{})) {
        }
        if (try dvui.button(@src(), "Zoom In", .{}, .{})) {
        }
    }
};
